controllers/RealizanController.php
<?php

namespace app\controllers;

use app\models\Realizan;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * RealizanController implements the CRUD actions for Realizan model.
 */
class RealizanController extends Controller
{
    /**
     * @inheritDoc
     */
    public function behaviors()
    {
        return array_merge(
            parent::behaviors(),
            [
                'verbs' => [
                    'class' => VerbFilter::className(),
                    'actions' => [
                        'delete' => ['POST'],
                    ],
                ],
            ]
        );
    }

    /**
     * Lists all Realizan models.
     *
     * @return string
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Realizan::find(),
            /*
            'pagination' => [
                'pageSize' => 50
            ],
            'sort' => [
                'defaultOrder' => [
                    'id' => SORT_DESC,
                ]
            ],
            */
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Realizan model.
     * @param int $id ID
     * @return string
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Realizan model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return string|\yii\web\Response
     */
    public function actionCreate()
    {
        $model = new Realizan();

        if ($this->request->isPost) {
            if ($model->load($this->request->post()) && $model->save()) {
                return $this->redirect(['view', 'id' => $model->id]);
            }
        } else {
            $model->loadDefaultValues();
        }
        
        // dataprovider de las salas
        $dataProvider1=new ActiveDataProvider([
            'query' => \app\models\Salas::todas(false)
        ]);
        
        // dataprovider de los monitores
        $dataProvider2=new ActiveDataProvider([
            'query' => \app\models\Monitor::find()
        ]);
        
        // dataprovider de las activadades
        $dataProvider3=new ActiveDataProvider([
            'query' => \app\models\Actividades::find()
        ]);
        
        return $this->render('create', [
            'model' => $model,
            'dataProvider1' => $dataProvider1,
            'dataProvider2' => $dataProvider2,
            'dataProvider3' => $dataProvider3
        ]);
    }

    /**
     * Updates an existing Realizan model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param int $id ID
     * @return string|\yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($this->request->isPost && $model->load($this->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Realizan model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param int $id ID
     * @return \yii\web\Response
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Realizan model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param int $id ID
     * @return Realizan the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Realizan::findOne(['id' => $id])) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}

controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::class,
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::class,
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        
        // $consulta= \Yii::$app->db->createCommand('select * from actividades')->queryAll();
        
        /**
         * mostrar las actividades que se realizan hoy
         */
        $dataProvider=new \yii\data\SqlDataProvider([
            'sql' => 'SELECT 
                        DISTINCT a.* 
                            FROM realizan r JOIN actividades a ON r.actividad = a.id
                            WHERE DATE_FORMAT(fechaHora,"%Y-%m-%d")=CURDATE()'
        ]);
        
        /**
         * mostrar las activades que mas veces se han impartido
         */
        $dataProvider1=new \yii\data\SqlDataProvider([
           'sql' => 'SELECT a.id,
                        a.nombre,
                        a.descripcion,
                        a.duracion,
                        a.imagen,
                        c1.repeticiones
                        FROM actividades a JOIN
                            (SELECT 
                              COUNT(*) repeticiones, r.actividad 
                              FROM realizan r 
                              GROUP BY r.actividad
                              ORDER BY repeticiones DESC) c1 ON a.id= c1.actividad' 
        ]);
        
        return $this->render('index',[
            'dataProvider' => $dataProvider,
            'dataProvider1' => $dataProvider1,
        ]);
    }

    /**
     * Login action.
     *
     * @return Response|string
     */
    public function actionLogin()
    {
        if (!Yii::$app->user->isGuest) {
            return $this->goHome();
        }

        $model = new LoginForm();
        if ($model->load(Yii::$app->request->post()) && $model->login()) {
            return $this->goBack();
        }

        $model->password = '';
        return $this->render('login', [
            'model' => $model,
        ]);
    }

    /**
     * Logout action.
     *
     * @return Response
     */
    public function actionLogout()
    {
        Yii::$app->user->logout();

        return $this->goHome();
    }

    /**
     * Displays contact page.
     *
     * @return Response|string
     */
    public function actionContact()
    {
        $model = new ContactForm();
        if ($model->load(Yii::$app->request->post()) && $model->contact(Yii::$app->params['adminEmail'])) {
            Yii::$app->session->setFlash('contactFormSubmitted');

            return $this->refresh();
        }
        return $this->render('contact', [
            'model' => $model,
        ]);
    }

    /**
     * Displays about page.
     *
     * @return string
     */
    public function actionAbout()
    {
        return $this->render('about');
    }
    
    public function actionHoy(){
        $dataProvider=new \yii\data\SqlDataProvider([
            "sql" => 'SELECT a.nombre,
                        a.descripcion,
                        a.duracion,
                        a.imagen,
                        c1.sala,
                        c1.monitor,
                        c1.fechaHora  
                        FROM actividades a JOIN 
                        (SELECT *
                            FROM realizan r 
                            WHERE DATE_FORMAT(fechaHora,"%Y-%m-%d")=CURDATE() 
                            AND r.fechaHora>NOW())c1 ON a.id=c1.actividad'
        ]);
        
        // realizar una consulta similar pero con activedataprovider
        $consulta= \app\models\Realizan::find()
                    ->where('DATE_FORMAT(fechaHora,"%Y-%m-%d")=CURDATE() AND fechaHora>NOW()');
        
        $dataProvider1=new \yii\data\ActiveDataProvider([
           "query" => $consulta 
        ]);
        
        return $this->render("hoy",[
            "dataProvider" => $dataProvider,
            "dataProvider1" => $dataProvider1
        ]);
    }
    
    public function actionInformacion($id){
        $consulta= \app\models\Realizan::find()
                    ->where("actividad={$id} AND DATE_FORMAT(fechaHora,'%Y-%m-%d')=CURDATE()");
        
        $dataProvider=new \yii\data\ActiveDataProvider([
            "query" => $consulta
        ]);
        
        return $this->render("informacion",[
            "dataProvider" => $dataProvider
        ]);
    }
}

views/site/error.php
<?php

/** @var yii\web\View $this */
/** @var string $name */
/** @var string $message */
/** @var Exception$exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/hoy.php
<?php

/** @var yii\web\View $this */

$this->title = 'Actividades para hoy';
?>
<div class="site-index">

    <div class="jumbotron text-center bg-transparent mt-5 mb-5">
        <h1 class="display-4">Gimnasio Alpe Formacion</h1>

        <p class="lead">Actividades que puedo realizar hoy</p>

    </div>
   
</div>

<div class="text-center">
    <?=    \yii\helpers\Html::img("@web/imgs/site/1.png") ?>
</div>

<div>
        <?php 
//        echo yii\grid\GridView::widget([
//            "dataProvider" => $dataProvider
//         ]); 
        ?>
</div>

<div>
        <?= yii\grid\GridView::widget([
            "dataProvider" => $dataProvider1,
            "columns" => [
                [
                    "attribute" => "actividad",
                    "value" => "actividad0.nombre"
                ],
                //"actividad0.nombre",
                "actividad0.duracion",
                "actividad0.descripcion",
                [
                    "attribute" => "imagen",
                    "format" => "raw",
                    "value" => function($modelo){
                        return yii\helpers\Html::img("@web/imgs/actividades/{$modelo->actividad0->imagen}",["style"=>"width:300px"]);
                    }
                ],
                [
                    "attribute" => "sala",
                    "value" => "sala0.nombre",
                ],
                //"sala0.nombre",
                [
                    "attribute" => "monitor",
                    "value" => "monitor0.nombre",
                ],
                //"monitor0.nombre",
                "fechaHora",
                [
                    'label' => 'Mas informacion',
                    'format' => 'raw',
                    'value' => function($modelo){
                        return yii\helpers\Html::a("ver mas...",["realizan/view","id"=>$modelo->id]);
                    }
                ],
                
            ]
         ]) ?>
</div>

views/site/index.php
<?php

/** @var yii\web\View $this */

$this->title = 'Gestion de actividades';
?>
<div class="site-index">

    <div class="jumbotron text-center bg-transparent mt-5 mb-5">
        <h1 class="display-4">Gimnasio Alpe Formacion</h1>

        <p class="lead">Gestion de actividades</p>

    </div>
   
</div>

<div class="text-center">
    <?=    \yii\helpers\Html::img("@web/imgs/site/1.png") ?>
</div>

<div>
       <h2>Las actividades disponibles de hoy son</h2>
        <?= yii\grid\GridView::widget([
            "dataProvider" => $dataProvider,
            "columns" => [
               "id",
                "nombre",
                "descripcion",
                "duracion",
                //"imagen",
                [
                'attribute' => 'imagen',
                'format' => 'raw',
                'value' => function($modelo){
                    return yii\helpers\Html::img("@web/imgs/actividades/{$modelo["imagen"]}",['style'=>'width:300px']);
                }
                ],
                [
                  'label' => 'mas informacion', 
                  'format' => 'raw',
                  'value' => function($modelo){
                    return yii\helpers\Html::a('ver mas...',['site/informacion','id'=> $modelo["id"]]);
                  }
                ],
            ],
            
        ]) ?>
</div>

<div>
       <h2>Las actividades mas veces impartidas</h2>
        <?= yii\grid\GridView::widget([
            "dataProvider" => $dataProvider1,
            "columns" => [
                "id",
                "nombre",
                "descripcion",
                "duracion",
                //"imagen",
                [
                'attribute' => 'imagen',
                'format' => 'raw',
                'value' => function($modelo){
                    return yii\helpers\Html::img("@web/imgs/actividades/{$modelo["imagen"]}",['style'=>'width:300px']);
                }
                ],
                "repeticiones",
                 [
                'class' => 'yii\grid\ActionColumn',
                'template' => '{datos} ',
                'buttons'=> [ 
                    'datos' => function($url,$modelo){
                        return "si";
                    }
                    ]
                ],
                        
            ],
           
        ]) ?>
</div>

views/site/informacion.php
<?php

/** @var yii\web\View $this */

$this->title = 'Actividades hoy';
?>
<div class="site-index">

    <div class="jumbotron text-center bg-transparent mt-5 mb-5">
        <h1 class="display-4">Gimnasio Alpe Formacion</h1>

        <p class="lead">Actividades de hoy</p>

    </div>
   
</div>

<div class="text-center">
    <?=    \yii\helpers\Html::img("@web/imgs/site/1.png") ?>
</div>

<div>
       <h2>Las actividades disponibles de hoy son</h2>
        <?= yii\grid\GridView::widget([
            "dataProvider" => $dataProvider,
            "columns" => [
                [
                    'attribute' => 'actividad',
                    'value'=> 'actividad0.nombre'
                ],
                [
                    'attribute' => 'duracion',
                    'value'=> 'actividad0.duracion'
                ],
                [
                    'attribute' => 'monitor',
                    'value'=> 'monitor0.nombre'
                ],
                [
                    'attribute' => 'sala',
                    'value'=> 'sala0.nombre'
                ],
                'fechaHora'
            ],
        ]) ?>
</div>